diff --git a/sys/dev/netif/ig_hal/e1000_ich8lan.c b/sys/dev/netif/ig_hal/e1000_ich8lan.c
index 17cae6883e..74996e3bcf 100644
--- a/sys/dev/netif/ig_hal/e1000_ich8lan.c
+++ b/sys/dev/netif/ig_hal/e1000_ich8lan.c
@@ -3972,15 +4072,16 @@ static s32 e1000_update_nvm_checksum_spt(struct e1000_hw *hw)
 		 */
 		ret_val = e1000_read_flash_dword_ich8lan(hw,
 							 i + old_bank_offset,
-							 &data32);
+							 &dword);
+
 		if (dev_spec->shadow_ram[i].modified) {
-			data32 &= 0xFFFF0000;
-			data32 |= dev_spec->shadow_ram[i].value & 0xffff;
+			dword &= 0xffff0000;
+			dword |= (dev_spec->shadow_ram[i].value & 0xffff);
 		}
 		if (dev_spec->shadow_ram[i + 1].modified) {
-			data32 &= 0x0000FFFF;
-			data32 |= (dev_spec->shadow_ram[i + 1].value & 0xffff)
-				  << 16;
+			dword &= 0x0000ffff;
+			dword |= ((dev_spec->shadow_ram[i + 1].value & 0xffff)
+				  << 16);
 		}
 		if (ret_val)
 			break;
@@ -3993,18 +4094,17 @@ static s32 e1000_update_nvm_checksum_spt(struct e1000_hw *hw)
 		 * while the write is still in progress
 		 */
 		if (i == E1000_ICH_NVM_SIG_WORD - 1)
-			data32 |= E1000_ICH_NVM_SIG_MASK << 16;
+			dword |= E1000_ICH_NVM_SIG_MASK << 16;
 
 		/* Convert offset to bytes. */
-		/*act_offset = (i + new_bank_offset) << 1;*/
+		act_offset = (i + new_bank_offset) << 1;
 
 		usec_delay(100);
 
-		/* Write the bytes to the new bank. */
+		/* Write the data to the new bank. Offset in words*/
 		act_offset = i + new_bank_offset;
-		ret_val = e1000_retry_write_flash_dword_ich8lan(hw,
-							       act_offset,
-							       data32);
+		ret_val = e1000_retry_write_flash_dword_ich8lan(hw, act_offset,
+								dword);
 		if (ret_val)
 			break;
 	 }
@@ -4024,16 +4124,16 @@ static s32 e1000_update_nvm_checksum_spt(struct e1000_hw *hw)
 	 */
 	act_offset = new_bank_offset + E1000_ICH_NVM_SIG_WORD;
 
-	/*offset in words but we read dword */
+	/*offset in words but we read dword*/
 	--act_offset;
+	ret_val = e1000_read_flash_dword_ich8lan(hw, act_offset, &dword);
 
-	ret_val = e1000_read_flash_dword_ich8lan(hw, act_offset, &data32);
 	if (ret_val)
 		goto release;
 
-	data32 &= 0xBFFFFFFF;
-	ret_val = e1000_retry_write_flash_dword_ich8lan(hw, act_offset * 2 + 1,
-							data32);
+	dword &= 0xBFFFFFFF;
+	ret_val = e1000_retry_write_flash_dword_ich8lan(hw, act_offset, dword);
+
 	if (ret_val)
 		goto release;
 
@@ -4042,11 +4142,17 @@ static s32 e1000_update_nvm_checksum_spt(struct e1000_hw *hw)
 	 * done without an erase because flash erase sets all bits
 	 * to 1's. We can write 1's to 0's without an erase
 	 */
-	/*act_offset = (old_bank_offset + E1000_ICH_NVM_SIG_WORD) * 2 + 1;*/
+	act_offset = (old_bank_offset + E1000_ICH_NVM_SIG_WORD) * 2 + 1;
 
-	/* offset in words but we read dwords */
+	/* offset in words but we read dword*/
 	act_offset = old_bank_offset + E1000_ICH_NVM_SIG_WORD - 1;
-	ret_val = e1000_read_flash_dword_ich8lan(hw, act_offset, &data32);
+	ret_val = e1000_read_flash_dword_ich8lan(hw, act_offset, &dword);
+
+	if (ret_val)
+		goto release;
+
+	dword &= 0x00FFFFFF;
+	ret_val = e1000_retry_write_flash_dword_ich8lan(hw, act_offset, dword);
 
 	if (ret_val)
 		goto release;
@@ -4317,18 +4423,29 @@ static s32 e1000_write_flash_data_ich8lan(struct e1000_hw *hw, u32 offset,
 		ret_val = e1000_flash_cycle_init_ich8lan(hw);
 		if (ret_val != E1000_SUCCESS)
 			break;
+		/* In SPT, This register is in Lan memory space, not
+		 * flash.  Therefore, only 32 bit access is supported
+		 */
 		if (hw->mac.type == e1000_pch_spt)
-			hsflctl.regval = E1000_READ_FLASH_REG(hw, ICH_FLASH_HSFSTS) >> 16;
+			hsflctl.regval =
+			    E1000_READ_FLASH_REG(hw, ICH_FLASH_HSFSTS)>>16;
 		else
-			hsflctl.regval = E1000_READ_FLASH_REG16(hw, ICH_FLASH_HSFCTL);
+			hsflctl.regval =
+			    E1000_READ_FLASH_REG16(hw, ICH_FLASH_HSFCTL);
 
 		/* 0b/1b corresponds to 1 or 2 byte size, respectively. */
 		hsflctl.hsf_ctrl.fldbcount = size - 1;
 		hsflctl.hsf_ctrl.flcycle = ICH_CYCLE_WRITE;
+		/* In SPT, This register is in Lan memory space,
+		 * not flash.  Therefore, only 32 bit access is
+		 * supported
+		 */
 		if (hw->mac.type == e1000_pch_spt)
-			E1000_WRITE_FLASH_REG(hw, ICH_FLASH_HSFSTS, hsflctl.regval << 16);
+			E1000_WRITE_FLASH_REG(hw, ICH_FLASH_HSFSTS,
+					      hsflctl.regval << 16);
 		else
-			E1000_WRITE_FLASH_REG16(hw, ICH_FLASH_HSFCTL, hsflctl.regval);
+			E1000_WRITE_FLASH_REG16(hw, ICH_FLASH_HSFCTL,
+						hsflctl.regval);
 
 		E1000_WRITE_FLASH_REG(hw, ICH_FLASH_FADDR, flash_linear_addr);
 
@@ -4367,13 +4484,13 @@ static s32 e1000_write_flash_data_ich8lan(struct e1000_hw *hw, u32 offset,
 }
 
 /**
- *  e1000_write_flash_data32_ich8lan - Writes 32-bit words to the NVM
- *  @hw: pointer to the HW structure
- *  @offset: The offset (in bytes) of the 32-bit word to read.
- *  @data: The byte(s) to write to the NVM.
- *
- *  Writes one/two bytes to the NVM using the flash access registers.
- **/
+*  e1000_write_flash_data32_ich8lan - Writes 4 bytes to the NVM
+*  @hw: pointer to the HW structure
+*  @offset: The offset (in bytes) of the dwords to read.
+*  @data: The 4 bytes to write to the NVM.
+*
+*  Writes one/two/four bytes to the NVM using the flash access registers.
+**/
 static s32 e1000_write_flash_data32_ich8lan(struct e1000_hw *hw, u32 offset,
 					    u32 data)
 {
@@ -4383,7 +4500,7 @@ static s32 e1000_write_flash_data32_ich8lan(struct e1000_hw *hw, u32 offset,
 	s32 ret_val;
 	u8 count = 0;
 
-	DEBUGFUNC("e1000_write_ich8_data");
+	DEBUGFUNC("e1000_write_flash_data32_ich8lan");
 
 	if (hw->mac.type == e1000_pch_spt) {
 		if (offset > ICH_FLASH_LINEAR_ADDR_MASK)
@@ -4391,32 +4508,37 @@ static s32 e1000_write_flash_data32_ich8lan(struct e1000_hw *hw, u32 offset,
 	}
 	flash_linear_addr = ((ICH_FLASH_LINEAR_ADDR_MASK & offset) +
 			     hw->nvm.flash_base_addr);
-
 	do {
 		usec_delay(1);
 		/* Steps */
 		ret_val = e1000_flash_cycle_init_ich8lan(hw);
 		if (ret_val != E1000_SUCCESS)
 			break;
-		if (hw->mac.type == e1000_pch_spt) {
-			hsflctl.regval = E1000_READ_FLASH_REG(hw, ICH_FLASH_HSFSTS) >> 16;
-		} else {
-			hsflctl.regval = E1000_READ_FLASH_REG16(hw, ICH_FLASH_HSFCTL);
-		}
 
-		/* 0b/1b corresponds to 1 or 2 byte size, respectively. */
-		hsflctl.hsf_ctrl.fldbcount = sizeof(int32_t) - 1;
+		/* In SPT, This register is in Lan memory space, not
+		 * flash.  Therefore, only 32 bit access is supported
+		 */
+		if (hw->mac.type == e1000_pch_spt)
+			hsflctl.regval = E1000_READ_FLASH_REG(hw,
+							      ICH_FLASH_HSFSTS)
+					 >> 16;
+		else
+			hsflctl.regval = E1000_READ_FLASH_REG16(hw,
+							      ICH_FLASH_HSFCTL);
+
+		hsflctl.hsf_ctrl.fldbcount = sizeof(u32) - 1;
 		hsflctl.hsf_ctrl.flcycle = ICH_CYCLE_WRITE;
 
 		/* In SPT, This register is in Lan memory space,
 		 * not flash.  Therefore, only 32 bit access is
 		 * supported
 		 */
-		if (hw->mac.type == e1000_pch_spt) {
-			E1000_WRITE_FLASH_REG(hw, ICH_FLASH_HSFSTS, hsflctl.regval << 16);
-		} else {
-			E1000_WRITE_FLASH_REG16(hw, ICH_FLASH_HSFCTL, hsflctl.regval);
-		}
+		if (hw->mac.type == e1000_pch_spt)
+			E1000_WRITE_FLASH_REG(hw, ICH_FLASH_HSFSTS,
+					      hsflctl.regval << 16);
+		else
+			E1000_WRITE_FLASH_REG16(hw, ICH_FLASH_HSFCTL,
+						hsflctl.regval);
 
 		E1000_WRITE_FLASH_REG(hw, ICH_FLASH_FADDR, flash_linear_addr);
 
@@ -4425,9 +4547,9 @@ static s32 e1000_write_flash_data32_ich8lan(struct e1000_hw *hw, u32 offset,
 		/* check if FCERR is set to 1 , if set to 1, clear it
 		 * and try the whole sequence a few more times else done
 		 */
-		ret_val =
-		    e1000_flash_cycle_ich8lan(hw,
-					      ICH_FLASH_WRITE_COMMAND_TIMEOUT);
+		ret_val = e1000_flash_cycle_ich8lan(hw,
+					       ICH_FLASH_WRITE_COMMAND_TIMEOUT);
+
 		if (ret_val == E1000_SUCCESS)
 			break;
 
@@ -4437,6 +4559,7 @@ static s32 e1000_write_flash_data32_ich8lan(struct e1000_hw *hw, u32 offset,
 		 * try...ICH_FLASH_CYCLE_REPEAT_COUNT times.
 		 */
 		hsfsts.regval = E1000_READ_FLASH_REG16(hw, ICH_FLASH_HSFSTS);
+
 		if (hsfsts.hsf_status.flcerr)
 			/* Repeat for some time before giving up. */
 			continue;
@@ -4449,7 +4572,6 @@ static s32 e1000_write_flash_data32_ich8lan(struct e1000_hw *hw, u32 offset,
 	return ret_val;
 }
 
-
 /**
  *  e1000_write_flash_byte_ich8lan - Write a single byte to NVM
  *  @hw: pointer to the HW structure
@@ -4469,30 +4591,33 @@ static s32 e1000_write_flash_byte_ich8lan(struct e1000_hw *hw, u32 offset,
 }
 
 /**
- *  e1000_retry_write_flash_byte_ich8lan - Writes a single byte to NVM
- *  @hw: pointer to the HW structure
- *  @offset: The offset of the byte to write.
- *  @byte: The byte to write to the NVM.
- *
- *  Writes a single byte to the NVM using the flash access registers.
- *  Goes through a retry algorithm before giving up.
- **/
-static s32 e1000_retry_write_flash_byte_ich8lan(struct e1000_hw *hw,
-						u32 offset, u8 byte)
+*  e1000_retry_write_flash_dword_ich8lan - Writes a dword to NVM
+*  @hw: pointer to the HW structure
+*  @offset: The offset of the word to write.
+*  @dword: The dword to write to the NVM.
+*
+*  Writes a single dword to the NVM using the flash access registers.
+*  Goes through a retry algorithm before giving up.
+**/
+static s32 e1000_retry_write_flash_dword_ich8lan(struct e1000_hw *hw,
+						 u32 offset, u32 dword)
 {
 	s32 ret_val;
 	u16 program_retries;
 
-	DEBUGFUNC("e1000_retry_write_flash_byte_ich8lan");
+	DEBUGFUNC("e1000_retry_write_flash_dword_ich8lan");
+
+	/* Must convert word offset into bytes. */
+	offset <<= 1;
+
+	ret_val = e1000_write_flash_data32_ich8lan(hw, offset, dword);
 
-	ret_val = e1000_write_flash_byte_ich8lan(hw, offset, byte);
 	if (!ret_val)
 		return ret_val;
-
 	for (program_retries = 0; program_retries < 100; program_retries++) {
-		DEBUGOUT2("Retrying Byte %2.2X at offset %u\n", byte, offset);
+		DEBUGOUT2("Retrying Byte %8.8X at offset %u\n", dword, offset);
 		usec_delay(100);
-		ret_val = e1000_write_flash_byte_ich8lan(hw, offset, byte);
+		ret_val = e1000_write_flash_data32_ich8lan(hw, offset, dword);
 		if (ret_val == E1000_SUCCESS)
 			break;
 	}
@@ -4503,30 +4628,30 @@ static s32 e1000_retry_write_flash_byte_ich8lan(struct e1000_hw *hw,
 }
 
 /**
- *  e1000_retry_write_flash_dword_ich8lan - Writes a 32-bit word to NVM
+ *  e1000_retry_write_flash_byte_ich8lan - Writes a single byte to NVM
  *  @hw: pointer to the HW structure
  *  @offset: The offset of the byte to write.
- *  @dword: The dword to write to the NVM.
+ *  @byte: The byte to write to the NVM.
  *
- *  Writes a single 32-bit word to the NVM using the flash access registers.
+ *  Writes a single byte to the NVM using the flash access registers.
  *  Goes through a retry algorithm before giving up.
  **/
-static s32 e1000_retry_write_flash_dword_ich8lan(struct e1000_hw *hw,
-						u32 offset, u32 dword)
+static s32 e1000_retry_write_flash_byte_ich8lan(struct e1000_hw *hw,
+						u32 offset, u8 byte)
 {
 	s32 ret_val;
 	u16 program_retries;
 
 	DEBUGFUNC("e1000_retry_write_flash_byte_ich8lan");
 
-	ret_val = e1000_write_flash_data32_ich8lan(hw, offset, dword);
+	ret_val = e1000_write_flash_byte_ich8lan(hw, offset, byte);
 	if (!ret_val)
 		return ret_val;
 
 	for (program_retries = 0; program_retries < 100; program_retries++) {
-		DEBUGOUT2("Retrying DWord %08X at offset %u\n", dword, offset);
+		DEBUGOUT2("Retrying Byte %2.2X at offset %u\n", byte, offset);
 		usec_delay(100);
-		ret_val = e1000_write_flash_data32_ich8lan(hw, offset, dword);
+		ret_val = e1000_write_flash_byte_ich8lan(hw, offset, byte);
 		if (ret_val == E1000_SUCCESS)
 			break;
 	}
@@ -4612,15 +4737,17 @@ static s32 e1000_erase_flash_bank_ich8lan(struct e1000_hw *hw, u32 bank)
 			 */
 			if (hw->mac.type == e1000_pch_spt)
 				hsflctl.regval =
-				    E1000_READ_FLASH_REG(hw, ICH_FLASH_HSFSTS) >> 16;
+				    E1000_READ_FLASH_REG(hw,
+							 ICH_FLASH_HSFSTS)>>16;
 			else
 				hsflctl.regval =
-				    E1000_READ_FLASH_REG16(hw, ICH_FLASH_HSFCTL);
+				    E1000_READ_FLASH_REG16(hw,
+							   ICH_FLASH_HSFCTL);
 
 			hsflctl.hsf_ctrl.flcycle = ICH_CYCLE_ERASE;
 			if (hw->mac.type == e1000_pch_spt)
 				E1000_WRITE_FLASH_REG(hw, ICH_FLASH_HSFSTS,
-							hsflctl.regval << 16);
+						      hsflctl.regval << 16);
 			else
 				E1000_WRITE_FLASH_REG16(hw, ICH_FLASH_HSFCTL,
 							hsflctl.regval);
@@ -5053,8 +5180,8 @@ static void e1000_initialize_hw_bits_ich8lan(struct e1000_hw *hw)
 	E1000_WRITE_REG(hw, E1000_RFCTL, reg);
 
 	/* Enable ECC on Lynxpoint */
-	if (hw->mac.type == e1000_pch_lpt ||
-	    hw->mac.type == e1000_pch_spt) {
+	if ((hw->mac.type == e1000_pch_lpt) ||
+	    (hw->mac.type == e1000_pch_spt)) {
 		reg = E1000_READ_REG(hw, E1000_PBECCSTS);
 		reg |= E1000_PBECCSTS_ECC_ENABLE;
 		E1000_WRITE_REG(hw, E1000_PBECCSTS, reg);
@@ -5603,19 +5730,18 @@ out:
  *  the PHY.
  *  On i217, setup Intel Rapid Start Technology.
  **/
-void e1000_resume_workarounds_pchlan(struct e1000_hw *hw)
+u32 e1000_resume_workarounds_pchlan(struct e1000_hw *hw)
 {
 	s32 ret_val;
 
 	DEBUGFUNC("e1000_resume_workarounds_pchlan");
-
 	if (hw->mac.type < e1000_pch2lan)
-		return;
+		return E1000_SUCCESS;
 
 	ret_val = e1000_init_phy_workarounds_pchlan(hw);
 	if (ret_val) {
 		DEBUGOUT1("Failed to init PHY flow ret_val=%d\n", ret_val);
-		return;
+		return ret_val;
 	}
 
 	/* For i217 Intel Rapid Start Technology support when the system
@@ -5629,7 +5755,7 @@ void e1000_resume_workarounds_pchlan(struct e1000_hw *hw)
 		ret_val = hw->phy.ops.acquire(hw);
 		if (ret_val) {
 			DEBUGOUT("Failed to setup iRST\n");
-			return;
+			return ret_val;
 		}
 
 		/* Clear Auto Enable LPI after link up */
@@ -5663,7 +5789,9 @@ release:
 		if (ret_val)
 			DEBUGOUT1("Error %d in resume workarounds\n", ret_val);
 		hw->phy.ops.release(hw);
+		return ret_val;
 	}
+	return E1000_SUCCESS;
 }
 
 /**
diff --git a/sys/dev/netif/ig_hal/e1000_ich8lan.h b/sys/dev/netif/ig_hal/e1000_ich8lan.h
index 81a9384998..edc1dd14cc 100644
--- a/sys/dev/netif/ig_hal/e1000_ich8lan.h
+++ b/sys/dev/netif/ig_hal/e1000_ich8lan.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_ICH8LAN_H_
 #define _E1000_ICH8LAN_H_
@@ -108,12 +108,22 @@
 #define E1000_FEXTNVM6_REQ_PLL_CLK	0x00000100
 #define E1000_FEXTNVM6_ENABLE_K1_ENTRY_CONDITION	0x00000200
 #define E1000_FEXTNVM6_K1_OFF_ENABLE	0x80000000
-
-
+/* bit for disabling packet buffer read */
+#define E1000_FEXTNVM7_DISABLE_PB_READ	0x00040000
+#define E1000_FEXTNVM7_SIDE_CLK_UNGATE	0x00000004
 #define E1000_FEXTNVM7_DISABLE_SMB_PERST	0x00000020
-
-#define E1000_CTRL_EXT_NVMVS	0x3	/*NVM valid sector */
-
+#define E1000_FEXTNVM9_IOSFSB_CLKGATE_DIS	0x00000800
+#define E1000_FEXTNVM9_IOSFSB_CLKREQ_DIS	0x00001000
+#define E1000_FEXTNVM11_DISABLE_PB_READ		0x00000200
+#define E1000_FEXTNVM11_DISABLE_MULR_FIX	0x00002000
+
+/* bit24: RXDCTL thresholds granularity: 0 - cache lines, 1 - descriptors */
+#define E1000_RXDCTL_THRESH_UNIT_DESC	0x01000000
+
+#define NVM_SIZE_MULTIPLIER 4096  /*multiplier for NVMS field*/
+#define E1000_FLASH_BASE_ADDR 0xE000 /*offset of NVM access regs*/
+#define E1000_CTRL_EXT_NVMVS 0x3 /*NVM valid sector */
+#define E1000_TARC0_CB_MULTIQ_3_REQ	(1 << 28 | 1 << 29)
 #define PCIE_ICH8_SNOOP_ALL	PCIE_NO_SNOOP_ALL
 
 #define E1000_ICH_RAR_ENTRIES	7
@@ -175,6 +185,8 @@
 
 #define E1000_NVM_K1_CONFIG	0x1B /* NVM K1 Config Word */
 #define E1000_NVM_K1_ENABLE	0x1  /* NVM Enable K1 bit */
+#define K1_ENTRY_LATENCY	0
+#define K1_MIN_TIME		1
 
 /* SMBus Control Phy Register */
 #define CV_SMB_CTRL		PHY_REG(769, 23)
@@ -188,6 +200,10 @@
 #define I218_ULP_CONFIG1_INBAND_EXIT	0x0020 /* Inband on ULP exit */
 #define I218_ULP_CONFIG1_WOL_HOST	0x0040 /* WoL Host on ULP exit */
 #define I218_ULP_CONFIG1_RESET_TO_SMBUS	0x0100 /* Reset to SMBus mode */
+/* enable ULP even if when phy powered down via lanphypc */
+#define I218_ULP_CONFIG1_EN_ULP_LANPHYPC	0x0400
+/* disable clear of sticky ULP on PERST */
+#define I218_ULP_CONFIG1_DIS_CLR_STICKY_ON_PERST	0x0800
 #define I218_ULP_CONFIG1_DISABLE_SMB_PERST	0x1000 /* Disable on PERST# */
 
 /* SMBus Address Phy Register */
@@ -226,6 +242,9 @@
 #define HV_PM_CTRL_PLL_STOP_IN_K1_GIGA	0x100
 #define HV_PM_CTRL_K1_ENABLE		0x4000
 
+#define I217_PLL_CLOCK_GATE_REG	PHY_REG(772, 28)
+#define I217_PLL_CLOCK_GATE_MASK	0x07FF
+
 #define SW_FLAG_TIMEOUT		1000 /* SW Semaphore flag timeout in ms */
 
 /* Inband Control */
@@ -306,13 +325,12 @@
 #define E1000_SVCR_OFF_TIMER_SHIFT	16
 #define E1000_SVT_OFF_HWM_MASK		0x0000001F
 
-#define E1000_PCI_REVISION_ID_REG	0x08
 void e1000_set_kmrn_lock_loss_workaround_ich8lan(struct e1000_hw *hw,
 						 bool state);
 void e1000_igp3_phy_powerdown_workaround_ich8lan(struct e1000_hw *hw);
 void e1000_gig_downshift_workaround_ich8lan(struct e1000_hw *hw);
 void e1000_suspend_workarounds_ich8lan(struct e1000_hw *hw);
-void e1000_resume_workarounds_pchlan(struct e1000_hw *hw);
+u32 e1000_resume_workarounds_pchlan(struct e1000_hw *hw);
 s32 e1000_configure_k1_ich8lan(struct e1000_hw *hw, bool k1_enable);
 void e1000_copy_rx_addrs_to_phy_ich8lan(struct e1000_hw *hw);
 s32 e1000_lv_jumbo_workaround_ich8lan(struct e1000_hw *hw, bool enable);
diff --git a/sys/dev/netif/ig_hal/e1000_mac.c b/sys/dev/netif/ig_hal/e1000_mac.c
index 7be02eff28..bea38fb0cd 100644
--- a/sys/dev/netif/ig_hal/e1000_mac.c
+++ b/sys/dev/netif/ig_hal/e1000_mac.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #include "e1000_api.h"
 
@@ -944,11 +944,7 @@ s32 e1000_check_for_serdes_link_generic(struct e1000_hw *hw)
  *  Read the EEPROM for the default values for flow control and store the
  *  values.
  **/
-#ifdef NO_82542_SUPPORT
-static s32 e1000_set_default_fc_generic(struct e1000_hw *hw)
-#else
 s32 e1000_set_default_fc_generic(struct e1000_hw *hw)
-#endif
 {
 	s32 ret_val;
 	u16 nvm_data;
@@ -2102,8 +2098,7 @@ s32 e1000_disable_pcie_master_generic(struct e1000_hw *hw)
 
 	while (timeout) {
 		if (!(E1000_READ_REG(hw, E1000_STATUS) &
-		      E1000_STATUS_GIO_MASTER_ENABLE) ||
-				E1000_REMOVED(hw->hw_addr))
+		      E1000_STATUS_GIO_MASTER_ENABLE))
 			break;
 		usec_delay(100);
 		timeout--;
diff --git a/sys/dev/netif/ig_hal/e1000_mac.h b/sys/dev/netif/ig_hal/e1000_mac.h
index a52086d429..5066611c66 100644
--- a/sys/dev/netif/ig_hal/e1000_mac.h
+++ b/sys/dev/netif/ig_hal/e1000_mac.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,15 +30,12 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_MAC_H_
 #define _E1000_MAC_H_
 
 void e1000_init_mac_ops_generic(struct e1000_hw *hw);
-#ifndef E1000_REMOVED
-#define E1000_REMOVED(a) (0)
-#endif /* E1000_REMOVED */
 void e1000_null_mac_generic(struct e1000_hw *hw);
 s32  e1000_null_ops_generic(struct e1000_hw *hw);
 s32  e1000_null_link_info(struct e1000_hw *hw, u16 *s, u16 *d);
@@ -72,9 +69,7 @@ s32  e1000_led_on_generic(struct e1000_hw *hw);
 s32  e1000_led_off_generic(struct e1000_hw *hw);
 void e1000_update_mc_addr_list_generic(struct e1000_hw *hw,
 				       u8 *mc_addr_list, u32 mc_addr_count);
-#ifndef NO_82542_SUPPORT
 s32  e1000_set_default_fc_generic(struct e1000_hw *hw);
-#endif
 s32  e1000_set_fc_watermarks_generic(struct e1000_hw *hw);
 s32  e1000_setup_fiber_serdes_link_generic(struct e1000_hw *hw);
 s32  e1000_setup_led_generic(struct e1000_hw *hw);
diff --git a/sys/dev/netif/ig_hal/e1000_manage.c b/sys/dev/netif/ig_hal/e1000_manage.c
index f0a32a9c25..75bdd7a1ed 100644
--- a/sys/dev/netif/ig_hal/e1000_manage.c
+++ b/sys/dev/netif/ig_hal/e1000_manage.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,10 +30,9 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #include "e1000_api.h"
-
 /**
  *  e1000_calculate_checksum - Calculate checksum for buffer
  *  @buffer: pointer to EEPROM
@@ -42,7 +41,7 @@
  *  Calculates the checksum for some buffer on a specified length.  The
  *  checksum calculated is returned.
  **/
-u8 e1000_calculate_checksum(u8 *buffer, u32 length)
+static u8 e1000_calculate_checksum(u8 *buffer, u32 length)
 {
 	u32 i;
 	u8 sum = 0;
diff --git a/sys/dev/netif/ig_hal/e1000_manage.h b/sys/dev/netif/ig_hal/e1000_manage.h
index 64fee06b6a..f451bd712b 100644
--- a/sys/dev/netif/ig_hal/e1000_manage.h
+++ b/sys/dev/netif/ig_hal/e1000_manage.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_MANAGE_H_
 #define _E1000_MANAGE_H_
@@ -45,7 +45,6 @@ s32  e1000_mng_write_cmd_header_generic(struct e1000_hw *hw,
 s32  e1000_mng_write_dhcp_info_generic(struct e1000_hw *hw,
 				       u8 *buffer, u16 length);
 bool e1000_enable_mng_pass_thru(struct e1000_hw *hw);
-u8 e1000_calculate_checksum(u8 *buffer, u32 length);
 s32 e1000_host_interface_command(struct e1000_hw *hw, u8 *buffer, u32 length);
 s32 e1000_load_firmware(struct e1000_hw *hw, u8 *buffer, u32 length);
 
diff --git a/sys/dev/netif/ig_hal/e1000_nvm.c b/sys/dev/netif/ig_hal/e1000_nvm.c
index ab7164d70a..ff20dcf2d9 100644
--- a/sys/dev/netif/ig_hal/e1000_nvm.c
+++ b/sys/dev/netif/ig_hal/e1000_nvm.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #include "e1000_api.h"
 
@@ -333,11 +333,7 @@ static void e1000_standby_nvm(struct e1000_hw *hw)
  *
  *  Terminates the current command by inverting the EEPROM's chip select pin.
  **/
-#ifdef NO_82542_SUPPORT
-static void e1000_stop_nvm(struct e1000_hw *hw)
-#else
 void e1000_stop_nvm(struct e1000_hw *hw)
-#endif
 {
 	u32 eecd;
 
diff --git a/sys/dev/netif/ig_hal/e1000_nvm.h b/sys/dev/netif/ig_hal/e1000_nvm.h
index a74e23ef8d..66461c7084 100644
--- a/sys/dev/netif/ig_hal/e1000_nvm.h
+++ b/sys/dev/netif/ig_hal/e1000_nvm.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_NVM_H_
 #define _E1000_NVM_H_
@@ -89,9 +89,7 @@ s32  e1000_write_nvm_microwire(struct e1000_hw *hw, u16 offset,
 s32  e1000_write_nvm_spi(struct e1000_hw *hw, u16 offset, u16 words,
 			 u16 *data);
 s32  e1000_update_nvm_checksum_generic(struct e1000_hw *hw);
-#ifndef NO_82542_SUPPORT
 void e1000_stop_nvm(struct e1000_hw *hw);
-#endif
 void e1000_release_nvm_generic(struct e1000_hw *hw);
 void e1000_get_fw_version(struct e1000_hw *hw,
 			  struct e1000_fw_version *fw_vers);
diff --git a/sys/dev/netif/ig_hal/e1000_osdep.h b/sys/dev/netif/ig_hal/e1000_osdep.h
index f47b2f3dd2..f1dab09a71 100644
--- a/sys/dev/netif/ig_hal/e1000_osdep.h
+++ b/sys/dev/netif/ig_hal/e1000_osdep.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -42,25 +42,23 @@
 #include <bus/pci/pcivar.h>
 #include <bus/pci/pcireg.h>
 
-#define usec_delay(x)		DELAY(x)
-#define usec_delay_irq usec_delay
-#define msec_delay(x)		DELAY(1000*(x))
-/* TODO: Should we be paranoid about delaying in interrupt context? */
-#define msec_delay_irq(x)	DELAY(1000*(x))
+#define usec_delay(x) DELAY(x)
+#define usec_delay_irq(x) usec_delay(x)
+#define msec_delay(x) DELAY(1000*(x))
+#define msec_delay_irq(x) DELAY(1000*(x))
 
 extern int e1000_debug;
 
-#define DEBUGPRINT(S, args...)		\
+#define DEBUGOUT(S, args...)		\
 do {					\
 	if (e1000_debug)		\
 		kprintf(S, ##args);	\
 } while (0)
-#define DEBUGFUNC(F)		DEBUGOUT(F)
-#define DEBUGOUT(S)		DEBUGPRINT(S)
-#define DEBUGOUT1(S,A)		DEBUGPRINT(S, A)
-#define DEBUGOUT2(S,A,B)	DEBUGPRINT(S, A, B)
-#define DEBUGOUT3(S,A,B,C)	DEBUGPRINT(S, A, B, C)
-#define DEBUGOUT7(S,A,B,C,D,E,F,G) DEBUGPRINT(S, A, B, C, D, E, F, G)
+#define DEBUGOUT1(S, args...)	DEBUGOUT(S, ##args)
+#define DEBUGOUT2(S, args...)	DEBUGOUT(S, ##args)
+#define DEBUGOUT3(S, args...)	DEBUGOUT(S, ##args)
+#define DEBUGOUT7(S, args...)	DEBUGOUT(S, ##args)
+#define DEBUGFUNC(F)		DEBUGOUT(F "\n")
 
 #define CMD_MEM_WRT_INVALIDATE	0x0010  /* BIT_4 */
 #define PCI_COMMAND_REGISTER	PCIR_COMMAND
@@ -114,21 +112,11 @@ struct e1000_osdep {
         ((struct e1000_osdep *)(hw)->back)->mem_bus_space_handle, \
         E1000_REGISTER(hw, reg))
 
-#define E1000_READ_REG16(hw, reg) \
-    bus_space_read_2(((struct e1000_osdep *)(hw)->back)->mem_bus_space_tag, \
-        ((struct e1000_osdep *)(hw)->back)->mem_bus_space_handle, \
-        E1000_REGISTER(hw, reg))
-
 #define E1000_WRITE_REG(hw, reg, value) \
     bus_space_write_4(((struct e1000_osdep *)(hw)->back)->mem_bus_space_tag, \
         ((struct e1000_osdep *)(hw)->back)->mem_bus_space_handle, \
         E1000_REGISTER(hw, reg), value)
 
-#define E1000_WRITE_REG16(hw, reg, value) \
-    bus_space_write_2(((struct e1000_osdep *)(hw)->back)->mem_bus_space_tag, \
-        ((struct e1000_osdep *)(hw)->back)->mem_bus_space_handle, \
-        E1000_REGISTER(hw, reg), value)
-
 #define E1000_READ_REG_ARRAY(hw, reg, index) \
     bus_space_read_4(((struct e1000_osdep *)(hw)->back)->mem_bus_space_tag, \
         ((struct e1000_osdep *)(hw)->back)->mem_bus_space_handle, \
@@ -139,8 +127,8 @@ struct e1000_osdep {
         ((struct e1000_osdep *)(hw)->back)->mem_bus_space_handle, \
         E1000_REGISTER(hw, reg) + ((index)<< 2), value)
 
-#define E1000_READ_REG_ARRAY_DWORD	E1000_READ_REG_ARRAY
-#define E1000_WRITE_REG_ARRAY_DWORD	E1000_WRITE_REG_ARRAY
+#define E1000_READ_REG_ARRAY_DWORD E1000_READ_REG_ARRAY
+#define E1000_WRITE_REG_ARRAY_DWORD E1000_WRITE_REG_ARRAY
 
 #define E1000_READ_REG_ARRAY_BYTE(hw, reg, index) \
     bus_space_read_1(((struct e1000_osdep *)(hw)->back)->mem_bus_space_tag, \
@@ -166,23 +154,19 @@ struct e1000_osdep {
         (hw)->io_base + 4, value); } while (0)
 
 #define E1000_READ_FLASH_REG(hw, reg) \
-    (((hw)->mac.type == e1000_pch_spt) ? E1000_READ_REG(hw, (reg) + 0xE000):   \
     bus_space_read_4(((struct e1000_osdep *)(hw)->back)->flash_bus_space_tag, \
-        ((struct e1000_osdep *)(hw)->back)->flash_bus_space_handle, reg))
+        ((struct e1000_osdep *)(hw)->back)->flash_bus_space_handle, reg)
 
 #define E1000_READ_FLASH_REG16(hw, reg) \
-    (((hw)->mac.type == e1000_pch_spt) ? E1000_READ_REG16(hw, (reg) + 0xE000): \
     bus_space_read_2(((struct e1000_osdep *)(hw)->back)->flash_bus_space_tag, \
-        ((struct e1000_osdep *)(hw)->back)->flash_bus_space_handle, reg))
+        ((struct e1000_osdep *)(hw)->back)->flash_bus_space_handle, reg)
 
 #define E1000_WRITE_FLASH_REG(hw, reg, value) \
-    (((hw)->mac.type == e1000_pch_spt) ? E1000_WRITE_REG(hw, (reg) + 0xE000, value):   \
     bus_space_write_4(((struct e1000_osdep *)(hw)->back)->flash_bus_space_tag, \
-        ((struct e1000_osdep *)(hw)->back)->flash_bus_space_handle, reg, value))
+        ((struct e1000_osdep *)(hw)->back)->flash_bus_space_handle, reg, value)
 
 #define E1000_WRITE_FLASH_REG16(hw, reg, value) \
-    (((hw)->mac.type == e1000_pch_spt) ? E1000_WRITE_REG16(hw, (reg) + 0xE000, value):   \
     bus_space_write_2(((struct e1000_osdep *)(hw)->back)->flash_bus_space_tag, \
-        ((struct e1000_osdep *)(hw)->back)->flash_bus_space_handle, reg, value))
+        ((struct e1000_osdep *)(hw)->back)->flash_bus_space_handle, reg, value)
 
 #endif	/* _DRAGONFLY_OS_H_ */
diff --git a/sys/dev/netif/ig_hal/e1000_phy.c b/sys/dev/netif/ig_hal/e1000_phy.c
index a1c69a037f..20299734f5 100644
--- a/sys/dev/netif/ig_hal/e1000_phy.c
+++ b/sys/dev/netif/ig_hal/e1000_phy.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #include "e1000_api.h"
 
@@ -3431,12 +3431,11 @@ static s32 e1000_access_phy_wakeup_reg_bm(struct e1000_hw *hw, u32 offset,
 					  u16 *data, bool read, bool page_set)
 {
 	s32 ret_val;
-	u16 reg, page;
+	u16 reg = BM_PHY_REG_NUM(offset);
+	u16 page = BM_PHY_REG_PAGE(offset);
 	u16 phy_reg = 0;
 
 	DEBUGFUNC("e1000_access_phy_wakeup_reg_bm");
-	reg = BM_PHY_REG_NUM(offset);
-	page = BM_PHY_REG_PAGE(offset);
 
 	/* Gig must be disabled for MDIO accesses to Host Wakeup reg page */
 	if ((hw->mac.type == e1000_pchlan) &&
@@ -3546,7 +3545,6 @@ static s32 __e1000_read_phy_reg_hv(struct e1000_hw *hw, u32 offset, u16 *data,
 		if (ret_val)
 			return ret_val;
 	}
-
 	/* Page 800 works differently than the rest so it has its own func */
 	if (page == BM_WUC_PAGE) {
 		ret_val = e1000_access_phy_wakeup_reg_bm(hw, offset, data,
@@ -3656,7 +3654,6 @@ static s32 __e1000_write_phy_reg_hv(struct e1000_hw *hw, u32 offset, u16 data,
 		if (ret_val)
 			return ret_val;
 	}
-
 	/* Page 800 works differently than the rest so it has its own func */
 	if (page == BM_WUC_PAGE) {
 		ret_val = e1000_access_phy_wakeup_reg_bm(hw, offset, &data,
